#ifndef _NT_LOG_H_
#define _NT_LOG_H_

#include "nt_abi.h"
#include "nt_file.h"

typedef ssize_t __cdecl ntapi_log_write(
	__in	void *		hfile,
	__in	const void *	buf,
	__in	size_t		bytes);


typedef int32_t __cdecl ntapi_log_fn_call(
	__in	void *			hfile		__optional,
	__in	const char *		fn_caller_name,
	__in	void *			fn_callee_addr,
	__in	uintptr_t		fn_ret,
	__in	ntapi_log_write*	pfn_log_write	__optional,
	__in	const char *		source		__optional,
	__in	int			line		__optional);


typedef int32_t __cdecl ntapi_log_msg(
	__in	void *			hfile		__optional,
	__in	const char *		source		__optional,
	__in	int			line		__optional,
	__in	const char *		fn_caller_name,
	__in	const char *		fmt,
	__in	uintptr_t		arg1,
	__in	uintptr_t		arg2,
	__in	uintptr_t		arg3,
	__in	uintptr_t		arg4,
	__in	uintptr_t		arg5,
	__in	uintptr_t		arg6,
	__in	ntapi_log_write*	pfn_log_write	__optional);

#endif
